// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/GlobalDropdownMenus",
	"cloudera/Util",
	"cloudera/BasicSearch",
	"cloudera/layout/AutoOverFlow2",
	"cloudera/layout/AjaxLink",
	"cloudera/layout/FormSubmitLink",
	"cloudera/layout/Toggler",
	"cloudera/form/LabelOver",
	"cloudera/IE7Fixes",
	"cloudera/common/I18n",
	"cloudera/common/AutoRefreshableCounter"
], function(GlobalDropdownMenus, Util, BasicSearch, AutoOverFlow2, AjaxLink, FormSubmitLink, Toggler, LabelOver, IE7Fixes, I18n, AutoRefreshableCounter) {
// For any pages that contains a H1, sets the document title.
return function (options) {
	var updatePageTitle = function(str) {
		if (str) {
			document.title = str + " - Cloudera " + $(".AppHeader .productName").text();
		} else {
			document.title = "Cloudera " + $(".AppHeader .productName").text();
		}
	};

	// by default, copy the first <H1> into the page title.
	var $h1 = $("h1:first");
	if ($h1.length > 0) {
		updatePageTitle($h1.text());
	} else {
		updatePageTitle("");
	}

	// Also allow page to update the page title on the fly.
	$.subscribe("updatePageTitle", updatePageTitle);

	$('body').on('click', '[class~=Toggler]', function (e) {
		var $target = $(e.target);
		if (!$target.hasClass("Toggler")) {
			$target = $target.closest("[class~=Toggler]");
		}
		if ($target.hasClass("Toggler")) {
			$target.Toggler('click');
		}
	});

	$('body').on('click.a.ajaxLink', '[class~=AjaxLink]', function (e) {
		var $target = $(e.target);
		if (!$target.hasClass("AjaxLink")) {
			$target = $target.closest("[class~=AjaxLink]");
		}
		if ($target.hasClass("AjaxLink")) {
			$target.AjaxLink('click');
			if (e) {
				e.preventDefault();
			}
		}
	});

	$('body').on('click.a.formSubmitLink', '[class~=FormSubmitLink]', function (e) {
		var $target = $(e.target);
		if (!$target.hasClass("FormSubmitLink")) {
			$target = $target.closest("[class~=FormSubmitLink]");
		}
		if ($target.hasClass("FormSubmitLink")) {
			$target.FormSubmitLink('click');
			if (e) {
				e.preventDefault();
			}
		}
	});

	$('.AutoRefreshableCounter').AutoRefreshableCounter();

	Util.setTestMode(options.testMode);
};
});
