// Copyright (c) 2011-2012 Cloudera, Inc.  All rights reserved.

/**
 * Contains JavaScript that interacts with the Settings page.
 */
define([], function() {
return function(options) {
	/**
	 * options = {
	 *	layoutName: the layout name;
	 *	layoutSelector: the jQuery selector for the layout element
	 * }
	 */

	layoutState.options.keys = "west__size,west__isClosed,south__size,south__isClosed";
	layoutState.options.path = "/cmf/";

	$(window).unload(function(){
		layoutState.save(options.layoutName);
	});

	window[options.layoutName] = $(options.layoutSelector).layout(
		$.extend({}, options.defaultSettings, layoutState.load(options.layoutName))
	);

	// Resize the south panel when an marker is selected to be at least
	// resizeToMinHeight.
	var onEventMarkerSelected = function() {
		var myLayout = $(options.layoutSelector).layout();
		var southSize = myLayout.state.south.size;
		var resizeToMinHeight = options.defaultSettings.south__size;
		
		if (resizeToMinHeight === undefined && options.defaultSettings.south) {
			resizeToMinHeight = options.defaultSettings.south.size;
		}

		if (resizeToMinHeight !== undefined && southSize < resizeToMinHeight) {
			myLayout.sizePane("south", resizeToMinHeight);
		}
	};
	jQuery.subscribe("eventMarkerSelected", onEventMarkerSelected);
};
});
