// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/Util",
	"cloudera/chart/AnyChart"
], function(Util, AnyChart) {

return function(options) {

	function fillMetricRangeParameters(obj, prefix, start, end) {
		obj[prefix + ".start"] = start;
		obj[prefix + ".end"] = end;
	}
	
	function onPointClick(e) {
		// TODO: fire an event to be caught by the task tracker table
		console.log(e.data.Attributes.xBucketMax);
		console.log(e.data.Attributes.yBucketMax);

		var xBucketMax = e.data.Attributes.xBucketMax;
		var yBucketMax = e.data.Attributes.yBucketMax;
		var xBucketMin = e.data.Attributes.xBucketMin;
		var yBucketMin = e.data.Attributes.yBucketMin;

		var params = {};
		params.activityName = options.jobId;
		params.query = options.query;
		fillMetricRangeParameters(params, "xRange", xBucketMin, xBucketMax);
		fillMetricRangeParameters(params, "yRange", yBucketMin, yBucketMax);

		$.get(options.tableUrl + "?" + $.param(params), function(response) {
			$("#taskTrackerTableContainer").html(Util.filterError(response));
		});
	}

	// Construct the Heatmap URL
	var urlParams = {};
	urlParams.id = options.jobId;
	urlParams.query = options.query;

	var params = {};
	params.xmlUrl = options.heatmapUrl + "?" + $.param(urlParams);

	var anyChart = new AnyChart(params, options.heatmapId);

	var chart = anyChart.getChart();
	chart.addEventListener('pointClick', onPointClick);
};

});
