// Copyright © 2012 Cloudera, Inc. All rights reserved.

define(["cloudera/cmf/include/ServiceStatusHealthTablePopup"],function(e){describe("ServiceStatusHealthTablePopup tests",function(){var t={tableId:"serviceStatusHealthTablePopupTable",roles:[{host:{hostName:"host1"}},{host:{hostName:"host2"}}],healthTestSummary:{}},n,r,i={fnSort:jasmine.createSpy(),fnSettings:jasmine.createSpy(),redrawTable:jasmine.createSpy()},s=e.HealthCheck,o=e.HealthCheckResult,u=e.filterHealthSummary,a=function(e){return{id:e,name:e}},f=function(e,t){return{text:e,tag:t}},l=function(e,t){var n=[],r;for(r=0;r<t;r++)n.push({name:"Host "+r});return{health:f(e,e),roles:n}},c=function(e){return{shortDisplayName:e,longDisplayName:e+" "+e,summary:[l("health1",1),l("health2",2)]}};beforeEach(function(){spyOn($.fn,"dataTable").andReturn(i),n=new e(t),r=$('<div id="serviceStatusHealthTablePopup"></div>').appendTo("body")}),afterEach(function(){r.remove()}),it("instantiates a RoleInstancesTable",function(){expect(n.roleInstancesTable).toBeTruthy()}),it("sorts by name as well as status",function(){expect($.fn.dataTable).wasCalled();var e=$.fn.dataTable.mostRecentCall.args[0];expect(e).toBeDefined(),expect(_.isArray(e.aaSorting)).toBeTruthy(),expect(e.aaSorting.length).toEqual(2);var t=e.aaSorting[0],n=e.aaSorting[1];expect(t.length).toEqual(2),expect(n.length).toEqual(2),expect(t[0]).toEqual(6),expect(t[1]).toEqual("asc"),expect(n[0]).toEqual(4),expect(n[1]).toEqual("asc")}),it("is not filtering by default",function(){expect(n.currentHealthCheckFilter()).toBeFalsy()}),it("applies the Knockout bindings during instantiation",function(){spyOn(ko,"applyBindings"),n=new e(t),expect(ko.applyBindings).wasCalledWith(n,r[0])}),it("does not show stats for empty summaries",function(){var e=new s({summary:{}});expect(e.stats).toEqual([])}),it("ignores stats for HISTORY_NOT_AVAIL",function(){var e=new s({summary:{HISTORY_NOT_AVAIL:l("unknown",0)}});expect(e.stats).toEqual([])}),it("sorts severities RED > YELLOW > NOT_AVAIL > GREEN",function(){var e=new s({summary:{GREEN:l("green",1),NOT_AVAIL:l("notAvail",2),YELLOW:l("yellow",3),RED:l("red",4)}});expect(e.stats).toBeDefined(),expect(e.stats.length).toEqual(4),expect(e.stats[0].html).toEqual('<span class="redHealth">4 red</span>'),expect(e.stats[1].html).toEqual('<span class="yellowHealth">3 yellow</span>'),expect(e.stats[2].html).toEqual('<span class="notAvailHealth">2 notAvail</span>'),expect(e.stats[3].html).toEqual('<span class="greenHealth">1 green</span>')}),it("returns summaries of the health checks",function(){n.healthSummary={SOME_CHECK1:c("Some Check1"),SOME_CHECK2:c("Some Check2")};var e=n.getSummary();expect(e.length).toEqual(2),expect(e[0].displayName).toEqual("Some Check1"),expect(e[1].displayName).toEqual("Some Check2")}),it("filters by health check roles when asked",function(){var e=jasmine.createSpy().andReturn("Host 3");n.roleInstancesTable={setFilterFunc:jasmine.createSpy(),redrawTable:jasmine.createSpy(),getHostName:e};var t=new o(l("green",7));n.filterByHealthCheckRoles(t),expect(n.roleInstancesTable.setFilterFunc).wasCalled(),expect(n.roleInstancesTable.redrawTable).wasCalled(),expect(n.roleInstancesTable.setFilterFunc.mostRecentCall.args.length).toEqual(1);var r=n.roleInstancesTable.setFilterFunc.mostRecentCall.args[0];expect(r(null)).toBeTruthy(),expect(r([])).toBeTruthy(),e.andReturn("Host 2");var i=["0","1","2","Host 2"];expect(r(i)).toBeTruthy(),e.andReturn("Host 37"),i=["0","1","2","Host 37"],expect(r(i)).toBeFalsy()}),it("correctly removes the filter once added",function(){n.roleInstancesTable={clearFilterFunc:jasmine.createSpy(),redrawTable:jasmine.createSpy()},spyOn(n,"currentHealthCheckFilter"),n.removeFilter(),expect(n.roleInstancesTable.clearFilterFunc).wasCalled(),expect(n.roleInstancesTable.redrawTable).wasCalled(),expect(n.currentHealthCheckFilter).wasCalledWith(null)}),it("summarizes a health check correctly",function(){var e=new o(l("green",5));expect(e.html).toEqual('<span class="greenHealth">5 green</span>'),expect(e.hostNames).toBeDefined(),expect(e.hostNames.length).toEqual(5)}),it("has a function called filterHealthSummary",function(){expect(u).toBeDefined()}),it("filters health checks we do not care about",function(){var e={HEALTH_CHECK_1:{summary:{GREEN:{roles:[a("h1")]}}},HEALTH_CHECK_2:{summary:{GREEN:{roles:[a("h2")]}}}},t={h2:!0},n=u(e,t);expect(n.HEALTH_CHECK_1).toBeUndefined(),expect(n.HEALTH_CHECK_2).toBeDefined()}),it("filters health check summaries we do not care about",function(){var e={HEALTH_CHECK_1:{summary:{GREEN:{roles:[a("h1")]},YELLOW:{roles:[a("h2")]}}}},t={h2:!0},n=u(e,t);expect(n.HEALTH_CHECK_1).toBeDefined(),expect(n.HEALTH_CHECK_1.summary.GREEN).toBeUndefined(),expect(n.HEALTH_CHECK_1.summary.YELLOW).toBeDefined()}),it("filters roles we do not care about",function(){var e={HEALTH_CHECK_1:{summary:{GREEN:{roles:[a("h1"),a("h2"),a("h3")]},YELLOW:{roles:[a("h2"),a("h3"),a("h4")]}}},HEALTH_CHECK_2:{summary:{GREEN:{roles:[a("h1"),a("h2"),a("h3")]},YELLOW:{roles:[a("h2"),a("h3"),a("h4")]}}}},t={h2:!0,h3:!0},n=u(e,t),r=n.HEALTH_CHECK_1.summary.GREEN.roles,i=n.HEALTH_CHECK_1.summary.YELLOW.roles,s=n.HEALTH_CHECK_2.summary.GREEN.roles,o=n.HEALTH_CHECK_2.summary.YELLOW.roles,f=function(e){expect(e[0].name).toEqual("h2"),expect(e[1].name).toEqual("h3")};expect(r.length).toEqual(2),f(r),expect(i.length).toEqual(2),f(i),expect(s.length).toEqual(2),f(s),expect(o.length).toEqual(2),f(o)})})})